//=============================================================================
// LanScan.c
// ணࠬ ᪠஢  Ethernet ⥬ 뤠 ARP-ᮢ
//=============================================================================
#define PURE_32
#define INCL_WIN
#define INCL_DOSMEMMGR
#ifndef DAEMON
#define INCL_GPIBITMAPS
#endif
#define INCL_DOSSEMAPHORES
#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#define INCL_DOSDATETIME
#define INCL_REXXSAA
#define INCL_DOSFILEMGR

#include <os2.h>
#include <bsememf.h>
#include <umalloc.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <netdb.h>
#include <types.h>
#include <sys\socket.h>
#include <sys\ioctl.h>
#include <netinet\in.h>
#include <net\route.h>
#include <net\if.h>
#include <net\if_arp.h>
#ifndef TCPV40HDRS   // ᪫  TCP/IP 4.0
#include <arpa\inet.h>
#include <unistd.h>
#endif               // TCPV40HDRS
#include <netcons.h>
#include <wksta.h>
#include <access.h>
#include <server.h>
#include <ncb.h>
#include <netbios.h>
#include <neterr.h>
#include <rexxsaa.h>   // needed for RexxStart()
#include <netinet\in_systm.h>
#ifndef TCPV40HDRS   // ᪫  TCP/IP 4.0
#include <netinet\ip.h>
#else
#include "ip.h"
#endif
#include <netinet\ip_icmp.h>
#include <shares.h>
#include <libc\sys\stat.h>
#include <sys/select.h>
#include "LanScan.h"

//-----------------------------------------------------------------------------
// Prototypes
//-----------------------------------------------------------------------------
static void * _Optlink get_fn(Heap_t usrheap, size_t *length, int *clean)
{
  void *p;
  int rc;

// Round up to the next chunk size
  *length = ((*length) / 65536) * 65536 + 65536;
  *clean = _BLOCK_CLEAN;
  rc = DosAllocMem(&p, *length, PAG_COMMIT | PAG_READ | PAG_WRITE | OBJ_ANY);
  if ( rc ) p=NULL;
  return (p);
}

static void _Optlink  release_fn(Heap_t usrheap, void *p, size_t size)
{
  DosFreeMem(p);
  return;
}

#ifndef TCPV40HDRS   // ᪫  TCP/IP 4.0
#define myFD_SET(fd, set) { \
    if (((fd_set *)(set))->fd_count < FD_SETSIZE) \
        ((fd_set *)(set))->fd_array[((fd_set *)(set))->fd_count++]=fd; }
#else
#define myFD_SET(fd, set) { FD_SET(fd, set); }
#endif

#ifndef DAEMON
MRESULT EXPENTRY ClientWndProc(HWND,ULONG,MPARAM,MPARAM);
MRESULT EXPENTRY DlgProcPING(HWND, ULONG, MPARAM, MPARAM); // Dlg proc (PING)
MRESULT EXPENTRY DlgProcOPT(HWND, ULONG, MPARAM, MPARAM);  // Dlg proc (OPT)
MRESULT EXPENTRY DlgProcARP(HWND, ULONG, MPARAM, MPARAM);  // Dlg proc (ARP)
void    APIENTRY DoScan(ULONG);
void             StartThreads(HWND);
void             GetIPname(HWND, char *, u_long);
ULONG            GetNBnames(HWND, char *, ULONG);
int              TCPBEUIscan(HWND);
int              NETBEUIscan(HWND, int);
void             PingRange(HWND, int);
void             SendErrMsg(HWND, char *);
void             SendWngMsg(HWND, char *);
void             InitContainer(HWND, BOOL);
void             PostErrMsg(ULONG, char *);
_inline void     InsertRecord(HWND, int, short);
#else
void    APIENTRY DoScan(void);
void             StartThreads(void);
void             GetIPname(char *, u_long);
ULONG            GetNBnames(char *, ULONG);
int              TCPBEUIscan(void);
int              NETBEUIscan(int);
void             PingRange(int);
#endif

void    APIENTRY CFGpgm(void);
void    APIENTRY ViewPgm(void);
_inline short    FindOUI (void);
_inline u_short  in_cksum(u_short *, int);
void             GetStorage(void);
BOOL             GetFileName(char *, char *);
void             DoSave(char *, char *, BOOL);
BOOL             TestAddr(int);
BOOL             TestInt(char *, char *, int);
BOOL             TestPing(char *, char *);
void             FormNCB(void);
void             GetIPaddr(short);
BOOL             TestBEUI(void);
void             SetTitle (BOOL);
void             SaveOpt (char *);
void             GetOpt (char *);
void             IniFormIP(void);
void             SendResult(void *);
BOOL             RcvFile(int, char *);
void             SndFile(int, char *);
void             AfterScan(void);
int              GetTCPBEUIn(char *, int);
void             SmbName(char *, char *, long);

//-----------------------------------------------------------------------------
// Global Variablies
//-----------------------------------------------------------------------------
HWND hwndFrame;
HPOINTER hIcon;
char pszCnrTitle[256];
typedef struct _USERRECORD
  { RECORDCORE  recordCore;
    PSZ         Status;
    PSZ         IPaddress;
    PSZ         MACaddress;
    PSZ         FQDName;
    PSZ         CompName;
    PSZ         NBname;
  } USERRECORD, *PUSERRECORD;
PCHAR pB;
char *IPfirst,   *MACfirst,   *FQDNfirst,  *NBfirst,
     *NBIPfirst, *NETBNfirst, *MACNBfirst, *CompNfirst,
     *IP,        *MAC,        *FQDN,       *NB,
     *NBIP,      *NETBN,      *MACNB,      *CompN;
int CurrNum = 0, NumNCB = 0;
struct in_addr *inadr;
struct in_addr *inaddr[MAXIPADR] = { (struct in_addr *)&sin[0].sin_addr,
                                     (struct in_addr *)&sin[1].sin_addr,
                                     (struct in_addr *)&sin[2].sin_addr,
                                     (struct in_addr *)&sin[3].sin_addr,
                                     (struct in_addr *)&sin[4].sin_addr,
                                     (struct in_addr *)&sin[5].sin_addr,
                                     (struct in_addr *)&sin[6].sin_addr,
                                     (struct in_addr *)&sin[7].sin_addr };
unsigned long *paddr[MAXIPADR] = { (unsigned long *)&sin[0].sin_addr,
                                   (unsigned long *)&sin[1].sin_addr,
                                   (unsigned long *)&sin[2].sin_addr,
                                   (unsigned long *)&sin[3].sin_addr,
                                   (unsigned long *)&sin[4].sin_addr,
                                   (unsigned long *)&sin[5].sin_addr,
                                   (unsigned long *)&sin[6].sin_addr,
                                   (unsigned long *)&sin[7].sin_addr };
ULONG ulEntriesAvailable, ulEntriesRead, ulSesRead=0, ulSesAvailable=0;
unsigned char *Net32Buf, DCName[UNCLEN+1], Nol[] = "<>", *pSes;
struct wksta_info_1 *pWkInf;
HEV hevEventHandle = 0;
#ifndef DAEMON
HEV hevEventStart = 0;
#endif
TID tid = 0, tidCFG = 0, tidView = 0;
HTIMER phtimer = 0;
ULONG ulPostCnt = 0, ulPostStart = 0;
unsigned char buf[L1024], *ptr, ErrMsg[L160];
static char LineSep[] = "------------";
short int *pi = (short int *)&buf;
char MyMAC[MAXIPADR*L6], *bufFind;
struct ncb NCBB[MAXIPADR] = { {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0} };
char NetName[MAXIPADR*(NETBIOS_NAME_LEN+1)], NewNBact;
struct netbios_info_1 *NBI1;
char ChkTCPB[MAXIPADR] = { '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0' };
struct tm *timeptr;
short NumOUI = 0, CNI, StatusIP[NUMADR];
int len = L254*sizeof(struct netbios_info_1);
long ColorWhite = CLR_WHITE, ColorBlack    = CLR_BLACK, ColorCyan = CLR_CYAN,
     ColorGreen = CLR_GREEN, ColorPaleGray = CLR_PALEGRAY;
struct statatreq TempAddrInfo[MAXIPADR] = { {0},{0},{0},{0},{0},{0},{0},{0} };
int TempNumIPadr = 0;
int TempInterv[MAXIPADR] = { 0, 0, 0, 0, 0, 0, 0, 0 };
struct _HostInt TempHostInt[MAXIPADR] = { {0},{0},{0},{0},{0},{0},{0},{0} };
BOOL flagSet = FALSE, flagRun = TRUE, FlagNewCFG = FALSE, FlagSrv = FALSE;
ULONG ulSize;  // Size of the data to be copied
PVOID pBuffer; // Buffer
char INIname[] = "LANSCAN.INI", CFGname[] = "LANSCAN.CFG";
char FileSrvName[L32];
PNOTIFYRECORDENTER Selected;
char ViewPWD[PWDLEN+1], RunPWD[PWDLEN+1], ReadPWD[PWDLEN+1],
     WritePWD[PWDLEN+1];
char TxtExist[4] = "",   TxtDel[4] = "Del", TxtAdd[4] = "Add",
     TxtRepl[4] = "Rep", TxtUpd[4] = "Upd";

//=============================================================================
// Main procedure
//=============================================================================
void main()
     {
     FILE *File;
     HMQ   hmq;                    // Message queue handle
     QMSG  qmsg;                   // Message struct
     ULONG flFrameFlags = FCF_TITLEBAR   | FCF_SYSMENU | FCF_SHELLPOSITION |
                          FCF_SIZEBORDER | FCF_MINMAX  | FCF_TASKLIST      |
                          FCF_ACCELTABLE | FCF_MENU    | FCF_AUTOICON;

#ifdef DAEMON
     PPIB pib;

     DosGetInfoBlocks(NULL, &pib);
     pib->pib_ultype = 3;            //  ਫ - PM
#endif

     memset(FileSrvName, '\0', sizeof(FileSrvName));

#ifdef TCPV40HDRS    //   TCP/IP 4.0
     sock_init();
#endif               // TCPV40HDRS

     pingtv.tv_sec = L1;    //  㬮砭 㤥  1 ᥪ㭤
     pingtv.tv_usec = L0;

     memset(WritePWD, '\0', sizeof(WritePWD));
     memset(ReadPWD,  '\0', sizeof(ReadPWD));
     memset(RunPWD,   '\0', sizeof(RunPWD));
     memset(ViewPWD,  '\0', sizeof(ViewPWD));
     if ( (File=fopen("LanScan.pwd", "r")) != NULL )
       {
       fgets(WritePWD, PWDLEN+1, File);
       if ( strlen(WritePWD) > 0 )
         if ( WritePWD[strlen(WritePWD)-1] == '\x0a' )
           WritePWD[strlen(WritePWD)-1] = '\0';
       fgets(ReadPWD, PWDLEN+1, File);
       if ( strlen(ReadPWD) > 0 )
         if ( ReadPWD[strlen(ReadPWD)-1] == '\x0a' )
           ReadPWD[strlen(ReadPWD)-1] = '\0';
       fgets(RunPWD, PWDLEN+1, File);
       if ( strlen(RunPWD) > 0 )
         if ( RunPWD[strlen(RunPWD)-1] == '\x0a' )
           RunPWD[strlen(RunPWD)-1] = '\0';
       fgets(ViewPWD, PWDLEN+1, File);
       if ( strlen(ViewPWD) > 0 )
         if ( ViewPWD[strlen(ViewPWD)-1] == '\x0a' )
           ViewPWD[strlen(ViewPWD)-1] = '\0';
       fclose(File);
       }
//-----------------------------------------------------------------------------
// Initialize application and create message queue
//-----------------------------------------------------------------------------
     hab = WinInitialize (0);
#ifndef DAEMON
     hmq = WinCreateMsgQueue (hab, 0);
#endif

     GetOpt(INIname);   // Get Options
     IniFormIP();
     GetStorage();
#ifdef DAEMON
     StartThreads();
     for ( ;; )
       {
       printf("%s\nEnter Ctrl-C for exit\n", TitleBar);
       while ( (getchar()) !='\x0a' ) ;
       }
#endif

#ifndef DAEMON
//-----------------------------------------------------------------------------
// Register class and create window
//-----------------------------------------------------------------------------
     WinRegisterClass (hab, "LanScan", ClientWndProc, CS_SIZEREDRAW, 0);
     hwndFrame = WinCreateStdWindow (HWND_DESKTOP,     // Parent
                                     0,                // Style (unvisible)
                                     &flFrameFlags,    // Creation flags
                                     "LanScan",        // Class name
                                     TitleBar,         // Titlebar text
                                     0,                // Client style
                                     NULLHANDLE,       // Resource handle
                                     MAIN_ID,          // Frame ID
                                     NULL);            // Client handle
     WinShowWindow(hwndFrame, TRUE);       // Make the window visible
//-----------------------------------------------------------------------------
// Set icon
//-----------------------------------------------------------------------------
     hIcon = (HPOINTER)WinLoadPointer(HWND_DESKTOP, NULLHANDLE, ICON_ID);
     WinPostMsg(hwndFrame, WM_SETICON, (MPARAM)hIcon, 0L);
//-----------------------------------------------------------------------------
// Message loop
//-----------------------------------------------------------------------------
     while (WinGetMsg (hab, &qmsg, 0, 0, 0)) WinDispatchMsg (hab, &qmsg);
//-----------------------------------------------------------------------------
// Clean up (destroy window, queue and hab)
//-----------------------------------------------------------------------------
     WinDestroyWindow (hwndFrame);
     WinDestroyMsgQueue (hmq);
#endif
     WinTerminate (hab);
     }

#ifndef DAEMON
//=============================================================================
// Window procedure
//=============================================================================
MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     static HWND hwndButtonRun, hwndButtonSave, hwndButtonExit, hwndStaticTxt,
                 hwndButtonBreak, hwndCntnr;
     static char Font[] = FontName;
     int i, j, k;
     ULONG Post;
     struct in_addr IndClient;
     SWP swp;
     char TCPBmsg[L32] = "TCPBEUI   ";
     char NETBmsg[L32] = "NETBEUI   ";
     char SMBmsg[L32]  = "SMBNAME   ";

     switch (msg)
          {
//-----------------------------------------------------------------------------
// Fill client with default color
//-----------------------------------------------------------------------------
          case WM_ERASEBACKGROUND:
          return MRFROMSHORT(TRUE);
//-----------------------------------------------------------------------------
// WM_CREATE occurs only during creation
//-----------------------------------------------------------------------------
          case WM_CREATE:
               {
               hwndButtonRun  =
               WinCreateWindow(hwnd,              // Parent handle
                               WC_BUTTON,         // Window class
                               "~Run",            // Window text
                               WS_VISIBLE | BS_PUSHBUTTON | WS_DISABLED,
                               0, 0, 0, 0,        // no size or position now
                               hwnd,              // Owner handle
                               HWND_TOP,          // Z-order ontop
                               PB_RUN,            // Window ID
                               0,                 // Control
                               0);                // Presentation Parameters
               hwndButtonBreak = WinCreateWindow(hwnd, WC_BUTTON, "~Break",
                                 WS_VISIBLE | BS_PUSHBUTTON,
                                 0, 0, 0, 0,
                                 hwnd, HWND_TOP, PB_BREAK, 0, 0);
               hwndButtonSave = WinCreateWindow(hwnd, WC_BUTTON, "~Save",
                                WS_VISIBLE | BS_PUSHBUTTON | WS_DISABLED,
                                0, 0, 0, 0,
                                hwnd, HWND_TOP, PB_SAVE, 0, 0);
               hwndButtonExit = WinCreateWindow(hwnd, WC_BUTTON, "~Exit",
                                WS_VISIBLE | BS_PUSHBUTTON,
                                0, 0, 0, 0,
                                hwnd, HWND_TOP, PB_EXIT, 0, 0);
               hwndCntnr = WinCreateWindow(hwnd,  // Parent
                               WC_CONTAINER,      // Window class
                               NULL,              // Window text
                               CCS_READONLY | CCS_SINGLESEL | WS_VISIBLE,
                               0, 0, 0, 0,        // no size or position now
                               hwnd,              // Owner handle
                               HWND_TOP,          // Z-order ontop
                               CONTAINER_ID,      // Window ID
                               0,                 // Control
                               0);                // Presentation Parameters
               hwndStaticTxt  =
               WinCreateWindow(hwnd,              // Parent handle
                               WC_STATIC,         // Window class
                               "",                // Window text
                               WS_VISIBLE | SS_TEXT | DT_LEFT | DT_VCENTER,
                               0, 0, 0, 0,        // no size or position now
                               hwnd,              // Owner handle
                               HWND_TOP,          // Z-order ontop
                               STATIC_ID,         // Window ID
                               0,                 // Control
                               0);                // Presentation Parameters
//-----------------------------------------------------------------------------
// Restore size & place from OS2.INI
//-----------------------------------------------------------------------------
     if ( !WinRestoreWindowPos(APPNAME, WINPOS,
                               WinQueryWindow(hwnd, QW_PARENT)) )
       WinSetWindowPos( WinQueryWindow(hwnd, QW_PARENT), HWND_TOP,
                        Win_X, Win_Y, Win_CX, Win_CY,
                        SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW );
//-----------------------------------------------------------------------------
// Set Presentation Parameters
//-----------------------------------------------------------------------------
     WinSetPresParam( hwnd, PP_FONTNAMESIZE, sizeof(Font), Font );
     WinSetPresParam( hwnd, PP_BACKGROUNDCOLORINDEX,
                      sizeof(ColorPaleGray), (PVOID)&ColorPaleGray );
     WinSetPresParam( hwnd, PP_FOREGROUNDCOLORINDEX,
                      sizeof(ColorBlack), (PVOID)&ColorBlack );
     WinSetPresParam( hwndCntnr, PP_BACKGROUNDCOLORINDEX,
                      sizeof(ColorWhite), (PVOID)&ColorWhite );
     WinSetPresParam( hwndCntnr, PP_FOREGROUNDCOLORINDEX,
                      sizeof(ColorBlack), (PVOID)&ColorBlack );
     WinSetPresParam( hwndCntnr, PP_HILITEBACKGROUNDCOLORINDEX,
                      sizeof(ColorCyan), (PVOID)&ColorCyan );
     WinSetPresParam( hwndCntnr, PP_HILITEFOREGROUNDCOLORINDEX,
                      sizeof(ColorBlack), (PVOID)&ColorBlack );
     WinSetPresParam( hwndStaticTxt, PP_BACKGROUNDCOLORINDEX,
                      sizeof(ColorGreen), (PVOID)&ColorGreen );
     WinSetPresParam( hwndStaticTxt, PP_FOREGROUNDCOLORINDEX,
                      sizeof(ColorBlack), (PVOID)&ColorBlack);
//-----------------------------------------------------------------------------
// Set Priority for current Thread, Create Semaphors and Threads.
//-----------------------------------------------------------------------------
               StartThreads(hwnd);
               WinSetFocus( HWND_DESKTOP, hwnd );  // ⠭ 䮪
               break;
               }
//-----------------------------------------------------------------------------
// WM_SIZE occurs during every resize, size setting event
//-----------------------------------------------------------------------------
          case WM_SIZE:
               {
               int x = (SHORT1FROMMP(mp2)-(4*PB_CX))/5;

               WinSetWindowPos(hwndButtonRun,      // Place and size button
                               HWND_TOP,           // ONTOP in Z-order
                               x,                  // x coord
                               Y,                  // y coord
                               PB_CX,              // cx size
                               PB_CY,              // cy size
                               SWP_SIZE|SWP_MOVE); // Change size|move
               WinSetWindowPos(hwndButtonBreak,    // Place and size button
                               HWND_TOP,           // ONTOP in Z-order
                               2*x+PB_CX,          // x coord
                               Y,                  // y coord
                               PB_CX,              // cx size
                               PB_CY,              // cy size
                               SWP_SIZE|SWP_MOVE); // Change size|move
               WinSetWindowPos(hwndButtonSave,     // Place and size button
                               HWND_TOP,           // ONTOP in Z-order
                               3*x+2*PB_CX,        // x coord
                               Y,                  // y coord
                               PB_CX,              // cx size
                               PB_CY,              // cy size
                               SWP_SIZE|SWP_MOVE); // Change size|move
               WinSetWindowPos(hwndButtonExit,     // Place and size button
                               HWND_TOP,           // ONTOP in Z-order
                               4*x+3*PB_CX,        // x coord
                               Y,                  // y coord
                               PB_CX,              // cx size
                               PB_CY,              // cy size
                               SWP_SIZE|SWP_MOVE); // Change size|move
               WinSetWindowPos(hwndCntnr,          // Place and size container
                               HWND_TOP,           // ONTOP in Z-order
                               0,                  // x coord
                               Y+PB_CY+Y+Txt_Y,    // y coord
                               SHORT1FROMMP(mp2),  // cx size
                               SHORT2FROMMP(mp2)-(Y+PB_CY+Y+Txt_Y),
                               SWP_SIZE|SWP_MOVE); // Change size|move
               WinSetWindowPos(hwndStaticTxt,      // Place and size container
                               HWND_TOP,           // ONTOP in Z-order
                               0,                  // x coord
                               Y+PB_CY+Y,          // y coord
                               SHORT1FROMMP(mp2),  // cx size
                               Txt_Y,              // cy size
                               SWP_SIZE|SWP_MOVE); // Change size|move
               break;
               }
//-----------------------------------------------------------------------------
// Save the window size and position on exit
//-----------------------------------------------------------------------------
          case WM_SAVEAPPLICATION:
               {
//-----------------------------------------------------------------------------
// Check if window is minimized and restore to original size
//-----------------------------------------------------------------------------
               if ( WinQueryWindowULong(hwndFrame, QWL_STYLE) & WS_MINIMIZED )
                 WinSetWindowPos(hwndFrame, HWND_TOP, 0, 0, 0, 0, SWP_RESTORE);
//-----------------------------------------------------------------------------
// Store window information in OS2.INI
//-----------------------------------------------------------------------------
               WinStoreWindowPos( APPNAME,
                                  WINPOS,
                                  WinQueryWindow(hwnd, QW_PARENT) );
//-----------------------------------------------------------------------------
// Copy the Window position info from the OS2.INI into private INI file
//-----------------------------------------------------------------------------
               PrfQueryProfileSize(HINI_USERPROFILE, APPNAME, WINPOS, &ulSize);
               pBuffer = calloc(ulSize, L1);
               PrfQueryProfileData( HINI_USERPROFILE, APPNAME, WINPOS,
                                    pBuffer, &ulSize);
               PrfWriteProfileData(HINI_USERPROFILE, APPNAME, NULL, NULL, 0);
               hini = PrfOpenProfile(hab, INIname); // Open private profile
               PrfWriteProfileData(hini, APPNAME, WINPOS, pBuffer, ulSize);
               PrfCloseProfile(hini);   // Close private profile
               free(pBuffer);

               break;
               }
//-----------------------------------------------------------------------------
// ନ஢ ப 襭
//-----------------------------------------------------------------------------
          case WM_USER_LINE_DONE:
               {
               InsertRecord( hwnd, LONGFROMMP(mp1), SHORT1FROMMP(mp2) );
               break;
               }
//-----------------------------------------------------------------------------
// ஢ 
//-----------------------------------------------------------------------------
          case WM_USER_SCAN_START:
            {
            WinEnableControl(hwnd, PB_RUN, FALSE);
            WinEnableControl(hwnd, PB_SAVE, FALSE);
            WinEnableControl(hwnd, PB_BREAK, TRUE);

            WinPostMsg( WinWindowFromID(hwnd, CONTAINER_ID),
                        CM_REMOVEDETAILFIELDINFO, NULL,
                        MPFROM2SHORT(L0, CMA_FREE | CMA_INVALIDATE) );

            WinDestroyWindow(hwndCntnr); //  ᮧ 
            hwndCntnr = WinCreateWindow(hwnd,     // Parent
                               WC_CONTAINER,      // Window class
                               NULL,              // Window text
                               CCS_READONLY | CCS_SINGLESEL | WS_VISIBLE,
                               0, 0, 0, 0,        // no size or position now
                               hwnd,              // Owner handle
                               HWND_TOP,          // Z-order ontop
                               CONTAINER_ID,      // Window ID
                               0,                 // Control
                               0);                // Presentation Parameters
            WinQueryWindowPos( hwnd, (PSWP)&swp );
            WinSetWindowPos(hwndCntnr,             // Place and size container
                               HWND_TOP,           // ONTOP in Z-order
                               0,                  // x coord
                               Y+PB_CY+Y+Txt_Y,    // y coord
                               swp.cx,             // cx size
                               swp.cy-(Y+PB_CY+Y+Txt_Y), // cy size
                               SWP_SIZE|SWP_MOVE); // Change size|move
            WinSetPresParam( hwndCntnr, PP_BACKGROUNDCOLORINDEX,
                             sizeof(ColorWhite), (PVOID)&ColorWhite );
            WinSetPresParam( hwndCntnr, PP_FOREGROUNDCOLORINDEX,
                             sizeof(ColorBlack), (PVOID)&ColorBlack );
            WinSetPresParam( hwndCntnr, PP_HILITEBACKGROUNDCOLORINDEX,
                             sizeof(ColorCyan), (PVOID)&ColorCyan );
            WinSetPresParam( hwndCntnr, PP_HILITEFOREGROUNDCOLORINDEX,
                             sizeof(ColorBlack), (PVOID)&ColorBlack );
            InitContainer(hwndCntnr, NewNBact);
            DosPostEventSem(hevEventStart);
            break;
            }
//-----------------------------------------------------------------------------
// ஢ 襭
//-----------------------------------------------------------------------------
          case WM_USER_SCAN_DONE:
            {
            WinSetWindowText(hwndStaticTxt, "");
            WinEnableControl(hwnd, PB_RUN, TRUE);
            WinEnableControl(hwnd, PB_BREAK, FALSE);
            WinEnableControl(hwnd, PB_SAVE, TRUE);
            WinSetPointer( HWND_DESKTOP,
                           WinQuerySysPointer(HWND_DESKTOP,SPTR_ARROW,FALSE) );
            WinInvalidateRegion(hwnd, NULLHANDLE, TRUE); //  
            break;
            }
//-----------------------------------------------------------------------------
// 믮塞  Net32GetDCName
//-----------------------------------------------------------------------------
          case WM_USER_NET32DCN:
               {
               char NET32DCNmsg[L32] = "Net32GetDCName ";

               strcpy(NET32DCNmsg+L15, PVOIDFROMMP(mp1));
               WinSetWindowText(hwndStaticTxt, NET32DCNmsg);
               break;
               }
//-----------------------------------------------------------------------------
// 믮塞  Net32ServerEnum2
//-----------------------------------------------------------------------------
          case WM_USER_NET32SE2:
               {
               char NET32SE2msg[L32] = "Net32ServerEnum2 ";

               strcpy(NET32SE2msg+L17, PVOIDFROMMP(mp1));
               WinSetWindowText(hwndStaticTxt, NET32SE2msg);
               break;
               }
//-----------------------------------------------------------------------------
// 믮塞  ARP
//-----------------------------------------------------------------------------
          case WM_USER_ARP:
               {
               char ARPmsg[L24] = "ARP ";

               IndClient.s_addr = LONGFROMMP(mp1);
               strcpy(ARPmsg+L4, inet_ntoa(IndClient));
               WinSetWindowText(hwndStaticTxt, ARPmsg);
               break;
               }
//-----------------------------------------------------------------------------
// 믮塞  DNS
//-----------------------------------------------------------------------------
          case WM_USER_DNS:
               {
               char DNSmsg[L24] = "DNS ";

               IndClient.s_addr = LONGFROMMP(mp1);
               strcpy(DNSmsg+L4, inet_ntoa(IndClient));
               WinSetWindowText(hwndStaticTxt, DNSmsg);
               break;
               }
//-----------------------------------------------------------------------------
// 믮塞  PING
//-----------------------------------------------------------------------------
          case WM_USER_PING:
               {
               char PINGmsg[L24] = "PING ";

               IndClient.s_addr = htonl(LONGFROMMP(mp1));
               strcpy(PINGmsg+L5, inet_ntoa(IndClient));
               WinSetWindowText(hwndStaticTxt, PINGmsg);
               break;
               }
//-----------------------------------------------------------------------------
// 믮塞  TCPBEUI
//-----------------------------------------------------------------------------
          case WM_USER_TCPBEUI:
               {
               strcpy( TCPBmsg+L10, pB+LONGFROMMP(mp1)*(UNCLEN-1) );
               WinSetWindowText(hwndStaticTxt, TCPBmsg);
               break;
               }
          case WM_USER_SMBNAME:
               {
               IndClient.s_addr = LONGFROMMP(mp1);
               strcpy( SMBmsg+L10, inet_ntoa(IndClient));
               WinSetWindowText(hwndStaticTxt, SMBmsg);
               break;
               }
          case WM_USER_SESTBEUI:
               {
               struct session_info_0 *session_i_0;

               session_i_0 = (struct session_info_0 *)pSes;
               strcpy( TCPBmsg+L10, (session_i_0+LONGFROMMP(mp1))->sesi0_cname);
               WinSetWindowText(hwndStaticTxt, TCPBmsg);
               break;
               }
//-----------------------------------------------------------------------------
// 믮塞  NETBEUI
//-----------------------------------------------------------------------------
          case WM_USER_NETBEUI:
               {
               strcpy( NETBmsg+L10, pB+LONGFROMMP(mp1)*(UNCLEN-1) );
               WinSetWindowText(hwndStaticTxt, NETBmsg);
               break;
               }
          case WM_USER_SESNBEUI:
               {
               struct session_info_0 *session_i_0;

               session_i_0 = (struct session_info_0 *)pSes;
               strcpy( NETBmsg+L10, (session_i_0+LONGFROMMP(mp1))->sesi0_cname);
               WinSetWindowText(hwndStaticTxt, NETBmsg);
               break;
               }
//-----------------------------------------------------------------------------
// 訡  ᪠஢
//-----------------------------------------------------------------------------
          case WM_USER_SCAN_ERROR:
               {
               SendErrMsg(hwnd, ErrMsg);
               break;
               }
//-----------------------------------------------------------------------------
// ࠡ⪠ 誨
//-----------------------------------------------------------------------------
          case WM_CONTROL:
            {
            switch (SHORT2FROMMP(mp1))
              {
              case CN_ENTER:
                {
                UCHAR LoadError[CCHMAXPATH] = { 0 };
                RESULTCODES ChieldRC = { 0 };
                char CmdLine[32];

                Selected = (PNOTIFYRECORDENTER)mp2;
                if ( Selected->pRecord->pszIcon[0] == '-' ) break;
                memset(CmdLine, '\0', sizeof(CmdLine));

#ifndef TCPV40HDRS   // ᪫  TCP/IP 4.0
                sprintf(CmdLine, "PortScan.exe%c%s", '\0',
                                 Selected->pRecord->pszIcon);
#else                //   TCP/IP 4.0
                sprintf(CmdLine, "PortScn4.exe%c%s", '\0',
                                 Selected->pRecord->pszIcon);
#endif               // TCPV40HDRS

                DosExecPgm( LoadError,
                            sizeof(LoadError),
                            EXEC_ASYNC,
                            CmdLine,
                            (PSZ)NULL,
                            &ChieldRC,
                            CmdLine );
                break;
                }
              }
            break;
            }
//-----------------------------------------------------------------------------
// ࠡ⪠ 
//-----------------------------------------------------------------------------
          case WM_INITMENU:
               {
               switch (SHORT1FROMMP(mp1))
                    {
                    case SUBMENU_FILE:
                         {
                         DosQueryEventSem( hevEventHandle, &Post );
                         WinEnableMenuItem((HWND)mp2, ITEM_RUN,    Post == 0);
                         WinEnableMenuItem((HWND)mp2, ITEM_BREAK,  Post != 0);
                         WinEnableMenuItem((HWND)mp2, ITEM_SAVE  , Post == 0);
                         WinEnableMenuItem((HWND)mp2, ITEM_SAVEAS, Post == 0);
                         WinEnableMenuItem((HWND)mp2, ITEM_ARP,    Post == 0);
                         WinEnableMenuItem((HWND)mp2, ITEM_PING,   Post == 0);
                         break;
                         }
                    break;
                    }
               }
          break;
//-----------------------------------------------------------------------------
// ࠡ⪠ 誨
//-----------------------------------------------------------------------------
          case WM_CONTROLPOINTER:
               {
               unsigned int idCtl = SHORT1FROMMP(mp1);
               if ( (idCtl != PB_RUN) && (idCtl != PB_SAVE) &&
                    (idCtl != CONTAINER_ID) && (idCtl != STATIC_ID) ) break;
               }
          case WM_MOUSEMOVE:
               {
               DosQueryEventSem(hevEventHandle, &Post);
               WinSetPointer( HWND_DESKTOP,
                              WinQuerySysPointer(HWND_DESKTOP,
                                                 Post ? SPTR_WAIT : SPTR_ARROW,
                                                 FALSE) );
               }
          return (MRESULT) TRUE;
//-----------------------------------------------------------------------------
// Handling of the menu-items and the button by WM_COMMAND
//-----------------------------------------------------------------------------
          case WM_COMMAND:
               {
               switch(SHORT1FROMMP(mp1))
                    {
//-----------------------------------------------------------------------------
// Close the dialog
//-----------------------------------------------------------------------------
                    case PB_EXIT:
                    case ITEM_EXIT:
                         {
                         WinPostMsg(hwnd, WM_CLOSE, 0L, 0L);
                         break;
                         }
//-----------------------------------------------------------------------------
// ࢥ ᪠஢
//-----------------------------------------------------------------------------
                    case PB_BREAK:
                    case ITEM_BREAK:
                         {
                         flagRun = FALSE;
                         break;
                         }
//-----------------------------------------------------------------------------
//  樨
//-----------------------------------------------------------------------------
                    case ITEM_SET_OPTIONS:
                         {
                         WinDlgBox (HWND_DESKTOP, // Parent
                                    hwnd,         // Owner
                                    DlgProcOPT,  // Dialog window procedure
                                    NULLHANDLE,   // Where is dialog resource?
                                    OPTIONS_ID,      // Dialog Resource ID
                                    0);       // Create parms (for WM_INITDLG)
                         if ( AutoRun ) DosAsyncTimer((ULONG)Interval*60000L,
                                                      (HSEM)hevEventHandle,
                                                      &phtimer);
                         else DosStopTimer(phtimer);   // ⠭ ⠩
                         break;
                         }
//-----------------------------------------------------------------------------
// Save Options to OS2.INI
//-----------------------------------------------------------------------------
                    case ITEM_SAVE_OPTIONS:
                         {
                         SaveOpt(INIname);
                         break;
                         }
//-----------------------------------------------------------------------------
// 뢥 Help
//-----------------------------------------------------------------------------
                    case ITEM_GENERAL_HELP:
                         {
                         UCHAR LoadError[CCHMAXPATH] = { 0 };
                         RESULTCODES ChieldRC = { 0 };
                         char CommandLine[] = "view.exe\0LanScan.Inf\0";

                         DosExecPgm( LoadError,
                                     sizeof(LoadError),
                                     EXEC_ASYNC,
                                     CommandLine,
                                     (PSZ)NULL,
                                     &ChieldRC,
                                     CommandLine );
                         WinSetFocus( HWND_DESKTOP, hwndCntnr );
                         break;
                         }
//-----------------------------------------------------------------------------
// ᪠  ᥡ
//-----------------------------------------------------------------------------
                    case ITEM_ABOUT:
                         {
                         WinDlgBox( HWND_DESKTOP,
                                    hwnd,
                                    WinDefDlgProc,
                                    NULLHANDLE,
                                    ABOUT_ID,
                                    0 );
                         WinSetFocus( HWND_DESKTOP, hwndCntnr );
                         break;
                         }
//-----------------------------------------------------------------------------
// 믮 ࠭ १⮢ ᪠஢
//-----------------------------------------------------------------------------
                    case ITEM_SAVEAS:
                         {
                         if ( !GetFileName(szTitle, szFullPath) )
                           {
                           WinSetFocus( HWND_DESKTOP, hwndCntnr );
                           break;
                           }
                         }
                    case PB_SAVE:
                    case ITEM_SAVE:
                         {
                         if ( szFullPath[0] != '\0' )
                           DoSave(szFullPath, "w", OldFormat);
                         else
                           if ( GetFileName(szTitle, szFullPath) )
                             DoSave(szFullPath, "w", OldFormat);

                         WinSetFocus( HWND_DESKTOP, hwndCntnr );
                         break;
                         }
//-----------------------------------------------------------------------------
// ⠭  ᮢ  PING
//-----------------------------------------------------------------------------
                    case ITEM_PING:
                         {
                         if ( flagSet ) break;
                         flagSet = TRUE;

                         WinDlgBox (HWND_DESKTOP, // Parent
                                    hwnd,         // Owner
                                    DlgProcPING,  // Dialog window procedure
                                    NULLHANDLE,   // Where is dialog resource?
                                    PING_ID,      // Dialog Resource ID
                                    0);       // Create parms (for WM_INITDLG)

                         flagSet = FALSE;
                         WinSetFocus( HWND_DESKTOP, hwndCntnr );

                         break;
                         }
//-----------------------------------------------------------------------------
// ⠭  ᮢ  ARP
//-----------------------------------------------------------------------------
                    case ITEM_ARP:
                         {
                         if ( flagSet ) break;
                         flagSet = TRUE;

                         WinDlgBox (HWND_DESKTOP, // Parent
                                    hwnd,         // Owner
                                    DlgProcARP,   // Dialog window procedure
                                    NULLHANDLE,   // Where is dialog resource?
                                    ARP_ID,       // Dialog Resource ID
                                    0);       // Create parms (for WM_INITDLG)

                         flagSet = FALSE;
                         WinSetFocus( HWND_DESKTOP, hwndCntnr );

                         break;
                         }
//-----------------------------------------------------------------------------
// 믮 ᪠஢
//-----------------------------------------------------------------------------
                    case PB_RUN:
                    case ITEM_RUN:
                         {
                         DosQueryEventSem( hevEventHandle, &Post );
                         if ( Post == 0 ) DosPostEventSem(hevEventHandle);
                         break;
                         }
                    }
               }
          break;
          }
     return (WinDefWindowProc (hwnd,msg,mp1,mp2));
     }
#endif
//=============================================================================
// DoScan - ணࠬ ᪠஢ 
//=============================================================================
#ifndef DAEMON
void APIENTRY DoScan(ULONG parmHwnd)
#else
void APIENTRY DoScan()
#endif
{
FILE *FileMap;
struct servent *WINSprot;
int i, j, k, l, m, n, NumNBN, NumNBNn, sock, resi, preCurrNum, currBase, ind;
int i1, j1;
unsigned long num, FirstNotMe = 0, preFirstNotMe;
unsigned long numMax[MAXIPADR];
unsigned long Mask[MAXIPADR];
struct arpreq myarp = { 0 };
char ReverseMAC[L6], *pp, BufDNname[DNLEN], *tptr;
time_t ltime;
BOOL ExistMAC;
char preMAC[MACLEN], preIP[IPLEN], currMAC[MACLEN], *oldMAC, *oldIP;
short currStatus;
char Record[MAPLEN];
#ifdef DAEMON
char temp[L32];
#endif

  DosSetPriority(PRTYS_THREAD, PRTYC_REGULAR, L15, L0);
  oldMAC = NULL;
  oldIP = NULL;

for (;;)
   {
   DosWaitEventSem(hevEventHandle, SEM_INDEFINITE_WAIT);
   DosStopTimer(phtimer);   // ⠭ ⠩
   if ( flagSet )
     {
     DosResetEventSem( hevEventHandle, &ulPostCnt);
     if ( AutoRun ) DosAsyncTimer( (ULONG)Interval*60000L,
                                   (HSEM)hevEventHandle, &phtimer );
     continue;
     }
//-----------------------------------------------------------------------------
// 믮 ⮢   ᪠஢
//-----------------------------------------------------------------------------
#ifndef DAEMON
   DosResetEventSem( hevEventStart, &ulPostStart);
#endif
   NewNBact = NBact;
   if ( NewNBact )
     {
     FormNCB();
     NBresult = TestBEUI();
     }
   SetTitle(NBresult);
#ifndef DAEMON
   WinPostMsg (parmHwnd, WM_USER_SCAN_START, L0, L0);
   DosWaitEventSem(hevEventStart, SEM_INDEFINITE_WAIT);
#endif
//-----------------------------------------------------------------------------
// 筥 ᪠஢
//-----------------------------------------------------------------------------
   time(&ltime);
   timeptr=localtime(&ltime);
#ifdef DAEMON
   strftime(temp, sizeof(temp)-1, "%d/%m/%Y %T", timeptr);
   printf("Scan started - %s\n", temp);
#endif
   if ( oldMAC != NULL )
     {
     free(oldMAC);
     free(oldIP);
     oldMAC = NULL;
     oldIP = NULL;
     }

   currBase = BaseInd;

   preCurrNum = CurrNum;
   preFirstNotMe = FirstNotMe;

   if ( currBase == BaseMap )
     {
//-----------------------------------------------------------------------------
// ନ㥬 ᨢ " "
//-----------------------------------------------------------------------------
     preFirstNotMe = 0;
     preCurrNum = 0;
     if ( (FileMap = fopen("LanScan.Map", "r")) != NULL )
       {
       for (i1=0; fgets(Record, MAPLEN, FileMap) != NULL; i1++);
       if ( i1 != 0 )
         {
         oldIP = calloc(IPLEN*i1, L1);
         oldMAC = calloc(MACLEN*i1, L1);
         rewind(FileMap);

         for (ind=0; ind<i1; ind++)
           {
           fgets(Record, MAPLEN, FileMap);
           if ( strlen(Record) > 0 )
             if ( Record[strlen(Record)-1] == '\x0a' )
               Record[strlen(Record)-1] = '\0';
           for ( j1=22; j1<strlen(Record); j1++)
             if ( Record[j1] == ' ' )
               {
               Record[j1] = '\0';
               break;
               }
           if ( (strlen(Record) < 22) || (strlen(Record) > 40) ) continue;
           memcpy(oldMAC+MACLEN*preCurrNum, Record, MACLEN-1);
           strcpy(oldIP+IPLEN*preCurrNum, Record+15);
           preCurrNum++;
           }
         }
       fclose(FileMap);
       }
     }
//-----------------------------------------------------------------------------
   if ( ( currBase == BaseLS ) && ( preCurrNum != 0 ) )
     {
     oldIP = calloc(IPLEN*preCurrNum, L1);
     oldMAC = calloc(MACLEN*preCurrNum, L1);
     for (i1=0, j1=0; j1<preCurrNum; j1++)
       {
       if ((StatusIP[j1]==TxtDel-TxtExist)||(StatusIP[j1]==TxtRepl-TxtExist))
         continue;
       memcpy(oldIP+i1*IPLEN, IPfirst+j1*IPLEN, IPLEN);
       memcpy(oldMAC+i1*MACLEN, MACfirst+j1*MACLEN, MACLEN);
       i1++;
       }
     preCurrNum = i1;
     }
//-----------------------------------------------------------------------------
   CurrNum = 0;
   for ( i=0; i<MAXIPADR; i++ )
     {
     numMax[i] = ~AddrInfoIP[i].mask;
     Mask[i] = htonl(AddrInfoIP[i].mask);
     }

   IP=IPfirst;
   MAC=MACfirst;
   FQDN=FQDNfirst;
   NB=NBfirst;
   NBIP=NBIPfirst;
   NETBN=NETBNfirst;
   MACNB=MACNBfirst;

   memset(IPfirst, '\0', IPLEN*NUMADR);
   memset(MACfirst, '\0', MACLEN*NUMADR);
   memset(FQDNfirst, '\0', FQDNLEN*NUMADR);
   memset(NETBNfirst, '\0', UNCLEN*NUMADR);
   memset(NBfirst, '\0', UNCLEN*L254);
   memset(NBIPfirst, '\0', IPLEN*L254);
   memset(MACNBfirst, '\0', MACLEN*L254);

   memset(preMAC, '\0', sizeof(preMAC));
   memset(currMAC, '\0', sizeof(currMAC));
   memset(StatusIP, '\0', sizeof(short)*NUMADR);

   sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
   if ( (WINSprot = getservbyname("netbios-ns", "udp")) == NULL  )
     for ( i=0; i<NumIPadr; i++) sin[i].sin_port = htons(NETBIOS_NS);
   else
     for ( i=0; i<NumIPadr; i++) sin[i].sin_port = WINSprot->s_port;
//-----------------------------------------------------------------------------
// Get all interface addresses
//-----------------------------------------------------------------------------
#ifndef TCPV40HDRS   // ᪫  TCP/IP 4.0
   os2_ioctl(sock, SIOSTATAT, (char *)buf, sizeof(buf));
#else                //   TCP/IP 4.0
   ioctl(sock, SIOSTATAT, (char *)buf, sizeof(buf));
#endif               // TCPV40HDRS
   for ( i=0, AdrInfo=(struct statatreq *)&buf[2]; i < *pi;
         i++, AdrInfo++,
         IP += IPLEN, MAC += MACLEN, FQDN += FQDNLEN, NETBN += UNCLEN )
     {
     inadr = (struct in_addr *)AdrInfo;
     strcpy(IP, inet_ntoa(*inadr));

     CNI = NumOUI;
     if ( (l=AdrInfo->interface) < MAXIPADR )
       {
       sprintf( MAC, "%2.2x%2.2x-%2.2x%2.2x-%2.2x%2.2x",
                MyMAC[l*L6],   MyMAC[l*L6+1], MyMAC[l*L6+2],
                MyMAC[l*L6+3], MyMAC[l*L6+4], MyMAC[l*L6+5] );
       CNI = FindOUI();
       }

#ifdef DAEMON
     GetIPname((char *)inadr, inadr->s_addr);
#else
     GetIPname(parmHwnd, (char *)inadr, inadr->s_addr);
     WinPostMsg ( parmHwnd, WM_USER_LINE_DONE,
                  MPFROMLONG(CurrNum), MPFROM2SHORT(CNI, 0) );
#endif
     CurrNum++;
     }
   FirstNotMe = CurrNum;
//-----------------------------------------------------------------------------
// 㥬  TCPBEUI  NETBEUI
//-----------------------------------------------------------------------------
   NumNBN, NumNBNn = 0;
   if ( NBresult )
     {
#ifndef DAEMON
     ulEntriesRead = GetNBnames(parmHwnd, pWkInf->wki1_logon_domain, L0);
#else
     ulEntriesRead = GetNBnames(pWkInf->wki1_logon_domain, L0);
#endif

     if ( useOTHD && (strlen(pWkInf->wki1_oth_domains)!= 0) )
       {
       for ( pp=pWkInf->wki1_oth_domains; ; pp=ptr+1 )
         {
         memset(BufDNname, '\0', sizeof(BufDNname));
         if ( (ptr=strchr(pp, ' ')) != NULL )
           {
           strncpy(BufDNname, pp, ptr-pp);
           if (strcmp(pWkInf->wki1_logon_domain, BufDNname) == 0 ) continue;
#ifndef DAEMON
           ulEntriesRead += GetNBnames(parmHwnd, BufDNname, ulEntriesRead);
#else
           ulEntriesRead += GetNBnames(BufDNname, ulEntriesRead);
#endif
           continue;
           }
         else
           {
           if (strcmp(pWkInf->wki1_logon_domain, pp) == 0 ) break;
#ifndef DAEMON
           ulEntriesRead += GetNBnames(parmHwnd, pp, ulEntriesRead);
#else
           ulEntriesRead += GetNBnames(pp, ulEntriesRead);
#endif
           break;
           }
         }
       }

     if ( ulEntriesRead != 0 )
       {
#ifndef DAEMON
       NumNBN = TCPBEUIscan(parmHwnd);
       NumNBNn = NETBEUIscan(parmHwnd, NumNBN);
#else
       NumNBN = TCPBEUIscan();
       NumNBNn = NETBEUIscan(NumNBN);
#endif
       }
     }
//-----------------------------------------------------------------------------
// 㥬 ⥬ ࠡ  襬 ARP
//-----------------------------------------------------------------------------
   for ( k=0; flagRun && (k<NumIPadr); k++ )
     {
//-----------------------------------------------------------------------------
// 뢥 ࠧ⥫ । ᪠஢  
//-----------------------------------------------------------------------------
     strcpy(IP, LineSep);
     strcpy(MAC, LineSep);
     strcpy(FQDN, LineSep);

     IP += IPLEN;
     MAC += MACLEN;
     FQDN += FQDNLEN;
     NETBN += UNCLEN;
#ifndef DAEMON
     WinPostMsg ( parmHwnd, WM_USER_LINE_DONE,
                  MPFROMLONG(CurrNum), MPFROM2SHORT(NumOUI, 0) );
#endif
     CurrNum++;
     if ( Interv[k] == 0 )
       {
       HostInt[k].start[Interv[k]] = 1;
       HostInt[k].stop[Interv[k]]  = numMax[k]-1;
       Interv[k] = 1;
       }

     for ( m=0; flagRun && (m<Interv[k]); m++ )
       {
       for ( num = HostInt[k].start[m];
             flagRun && (num <= HostInt[k].stop[m]) & (CurrNum < NUMADR);
             num++ )
         {
         *paddr[k] &= Mask[k];
         *paddr[k] |= htonl(num);
         memset( &myarp, 0, sizeof(myarp) );
         memcpy( &myarp.arp_pa, &sin[k], sizeof(myarp.arp_pa) );
         ptr = &myarp.arp_ha.sa_data[0];

         ExistMAC = FALSE;
         if ( currBase == BaseARP ) // ᯮ㥬  ARP
           {
#ifdef TCPV40HDRS    //   TCP/IP 4.0
           if ( ioctl(sock, SIOCGARP, (char *)&myarp, sizeof(myarp)) == 0 )
             if ( memcmp(ptr, "\0\0\0\0\0", L6) != 0 )
               {
               sprintf(preMAC, "%2.2x%2.2x-%2.2x%2.2x-%2.2x%2.2x",
                       *ptr, *(ptr+1), *(ptr+2), *(ptr+3), *(ptr+4), *(ptr+5));
               ExistMAC = TRUE;
               }
#else
           if ( ioctl(sock, SIOCGARP, &myarp) == 0 )
             {
             sprintf(preMAC, "%2.2x%2.2x-%2.2x%2.2x-%2.2x%2.2x",
                     *ptr, *(ptr+1), *(ptr+2), *(ptr+3), *(ptr+4), *(ptr+5));
             ExistMAC = TRUE;
             }
#endif
           }
         else
           {
           strcpy(preIP, inet_ntoa(*inaddr[k]));
           for (ind=preFirstNotMe, tptr=oldIP+IPLEN*preFirstNotMe;
                ind<preCurrNum; ind++)
             {
             if ( strcmp(preIP, tptr) == 0 )
               {
               strcpy(preMAC, oldMAC+MACLEN*ind);
               ExistMAC = TRUE;
               break;
               }
             tptr += IPLEN;
             }
           }

         memset( &myarp, 0, sizeof(myarp) );
         memcpy( &myarp.arp_pa, &sin[k], sizeof(myarp.arp_pa) );

#ifndef DAEMON
         WinPostMsg (parmHwnd, WM_USER_ARP, MPFROMLONG(*paddr[k]), 0L);
#endif

#ifdef TCPV40HDRS    //   TCP/IP 4.0
//-----------------------------------------------------------------------------
//     ARP
//-----------------------------------------------------------------------------
         ioctl(sock, SIOCDARP, (char *)&myarp, sizeof(myarp));
//-----------------------------------------------------------------------------
// 뤠  ARP
//-----------------------------------------------------------------------------
         sendto( sock, (char *)&num, sizeof(num), 0,
                 (struct sockaddr *)&sin[k], sizeof(struct sockaddr) );
//-----------------------------------------------------------------------------
// ⠥    ARP
//-----------------------------------------------------------------------------
         DosSleep(ArpWait);
         resi=ioctl(sock,SIOCGARP,(char *)&myarp,sizeof(myarp));
         if ( resi && !ExistMAC ) continue;
         if ( !resi && !memcmp(ptr, "\0\0\0\0\0", L6) )
           { //     ARP
           ioctl(sock, SIOCDARP, (char *)&myarp, sizeof(myarp));
           if ( !ExistMAC ) continue;
           }
#else                // ᪫  TCP/IP 4.0
//-----------------------------------------------------------------------------
//     ARP
//-----------------------------------------------------------------------------
         ioctl(sock, SIOCDARP, &myarp);
//-----------------------------------------------------------------------------
// 뤠  ARP
//-----------------------------------------------------------------------------
         ioctl(sock, SIOCARP, inaddr[k]);
//-----------------------------------------------------------------------------
// ⠥    ARP
//-----------------------------------------------------------------------------
         DosSleep(ArpWait);
         resi = ioctl(sock, SIOCGARP, &myarp);
         if ( resi && !ExistMAC ) continue;
#endif               // TCPV40HDRS

         if ( resi && ExistMAC ) // 㧫 ⥯ 
           {
           strcpy(IP, inet_ntoa(*inaddr[k]));
           strcpy(MAC, preMAC);
           CNI = FindOUI();
#ifdef DAEMON
           GetIPname((char *)paddr[k], *paddr[k]);
#else
           GetIPname(parmHwnd, (char *)paddr[k], *paddr[k]);
#endif
           IP += IPLEN;
           MAC += MACLEN;
           FQDN += FQDNLEN;
           NETBN += UNCLEN;
           StatusIP[CurrNum] = TxtDel-TxtExist;
#ifndef DAEMON
           WinPostMsg ( parmHwnd, WM_USER_LINE_DONE,
                        MPFROMLONG(CurrNum), MPFROM2SHORT(CNI, 0) );
#endif
           CurrNum++;
           continue;
           }

         strcpy(IP, inet_ntoa(*inaddr[k]));
         sprintf(currMAC, "%2.2x%2.2x-%2.2x%2.2x-%2.2x%2.2x",
                 *ptr, *(ptr+1), *(ptr+2), *(ptr+3), *(ptr+4), *(ptr+5));
         if ( ExistMAC ) // 㧥   
           {
           if ( strcmp(preMAC, currMAC) ) //  ARP   
             {
             strcpy(MAC, preMAC);
             CNI = FindOUI();

             IP += IPLEN;
             MAC += MACLEN;
             FQDN += FQDNLEN;
             NETBN += UNCLEN;
             StatusIP[CurrNum] = TxtRepl-TxtExist;
#ifndef DAEMON
             WinPostMsg ( parmHwnd, WM_USER_LINE_DONE,
                          MPFROMLONG(CurrNum), MPFROM2SHORT(CNI, 0) );
#endif
             CurrNum++;
             currStatus = TxtUpd-TxtExist; //   
             }
           else currStatus = TxtExist-TxtExist; //  㦥 饩 
           }
         else currStatus = TxtAdd-TxtExist; //   

         strcpy(IP, inet_ntoa(*inaddr[k]));
         strcpy(MAC, currMAC);
#ifdef DAEMON
         GetIPname((char *)paddr[k], *paddr[k]);
#else
         GetIPname(parmHwnd, (char *)paddr[k], *paddr[k]);
#endif
//-----------------------------------------------------------------------------
// 뢮 १ ᪠஢
//-----------------------------------------------------------------------------
         if ( NBresult )
           {
           for (j=0, NBIP=NBIPfirst, NB=NBfirst, MACNB=MACNBfirst; j<NumNBNn;
                j++, NBIP+=IPLEN, NB+=UNCLEN, MACNB+=MACLEN)
             {
             if ( j < NumNBN )
               {
               if ( strcmp(NBIP, IP) == 0 )
                 {
                 strcpy(NETBN, NB);
                 break;
                 }
               }
             else
               {
               for (i=0; i<L6; i++) ReverseMAC[L5-i]=MACNB[i];
               if ( (memcmp(MACNB, ptr, L6) == 0) ||
                    (memcmp(ReverseMAC, ptr, L6) == 0) )
                 {
                 strcpy(NETBN, NB);
                 break;
                 }
               }
             }
           }

         if ( NewNBact && ( *NETBN == '\0' ) )
           {
#ifndef DAEMON
           WinPostMsg (parmHwnd, WM_USER_SMBNAME, MPFROMLONG(*paddr[k]), 0L);
#endif
           SmbName(NETBN, IP, TcpWait);
           }

         CNI = FindOUI();

         IP += IPLEN;
         MAC += MACLEN;
         FQDN += FQDNLEN;
         NETBN += UNCLEN;
         StatusIP[CurrNum] = currStatus;
#ifndef DAEMON
         WinPostMsg ( parmHwnd, WM_USER_LINE_DONE,
                      MPFROMLONG(CurrNum), MPFROM2SHORT(CNI, 0) );
#endif
         CurrNum++;
         }
       }
     }
//-----------------------------------------------------------------------------
// ஥ socket
//-----------------------------------------------------------------------------
   soclose(sock);
//-----------------------------------------------------------------------------
// 믮 Ping
//-----------------------------------------------------------------------------
#ifndef DAEMON
   for ( i=0; flagRun && (i<NumPing); i++) PingRange(parmHwnd, i);
#else
   for ( i=0; flagRun && (i<NumPing); i++) PingRange(i);
#endif
//-----------------------------------------------------------------------------
// 訬 ᪠஢
//-----------------------------------------------------------------------------
   DosResetEventSem( hevEventHandle, &ulPostCnt);
   AfterScan();
#ifdef DAEMON
   printf("Scan ended\n");
#endif
#ifndef DAEMON
   WinPostMsg (parmHwnd, WM_USER_SCAN_DONE, 0L, 0L);
#endif
   }
}

//=============================================================================
// GetNBnames - ணࠬ 祭  NetBIOS
//=============================================================================
#ifndef DAEMON
ULONG GetNBnames(HWND hwndNum, char *ptrDN, ULONG j)
#else
ULONG GetNBnames(char *ptrDN, ULONG j)
#endif
{
   int i;
   ULONG eSave;
#ifndef DAEMON
   WinPostMsg ( hwndNum, WM_USER_NET32DCN, MPFROMP(ptrDN), 0L );
#endif
   if ( (i=Net32GetDCName(NULL, ptrDN, DCName, sizeof(DCName))) != 0 )
     if ( i != NERR_DCNotFound ) return L0;

   if ( i == 0 )
     {
#ifndef DAEMON
     WinPostMsg ( hwndNum, WM_USER_NET32SE2, MPFROMP(DCName), 0L );
#endif
     i = Net32ServerEnum2( DCName, L0, pB+j*(UNCLEN-1),
                           (UNCLEN-1)*(L254-j), &eSave,
                           &ulEntriesAvailable,
                           0xFFFFFFFF, ptrDN );
     }
   else
     {
#ifndef DAEMON
     WinPostMsg ( hwndNum, WM_USER_NET32SE2, MPFROMP(Nol), 0L );
#endif
     i = Net32ServerEnum2( NULL, L0, pB+j*(UNCLEN-1),
                           (UNCLEN-1)*(L254-j), &eSave,
                           &ulEntriesAvailable,
                           0xFFFFFFFF, ptrDN );
     }
   if ( i != 0 ) return L0;

   return eSave;
}

//=============================================================================
// TCPBEUIscan - ணࠬ ᪠஢  ⮪ TCPBEUI
//=============================================================================
#ifndef DAEMON
int TCPBEUIscan(HWND hwndNum)
#else
int TCPBEUIscan(void)
#endif
{
   int i, j, NumberNBN = 0;
   struct session_info_0 *ses_i_0;
   struct {
     short int Id;
     short int Flag;
     short int NQ;
     short int NAnsRR;
     short int NAutRR;
     short int NAddRR;
     char NBname[34];
     short int QT;
     short int QC; } NBQ;
//               123456789x123456789x123456789x123
   char NBN[] = " CACACACACACACACACACACACACACACACA";

   NBQ.Id     = 10001;
   NBQ.Flag   = htons(0x0110);
   NBQ.NQ     = htons(0x0001);
   NBQ.NAnsRR = 0;
   NBQ.NAutRR = 0;
   NBQ.NAddRR = 0;
   NBQ.QT     = htons(0x0020);
   NBQ.QC     = htons(0x0001);

   for ( ses_i_0 = (struct session_info_0 *)pSes, i=0;
         flagRun && (i<ulSesRead); i++, ses_i_0++ )
     {
#ifndef DAEMON
     WinPostMsg ( hwndNum, WM_USER_SESTBEUI, MPFROMLONG((long)i), 0L );
#endif
     strcpy(NBQ.NBname,NBN);
     for (j=0; j<strlen(ses_i_0->sesi0_cname); j++)
       {
       NBQ.NBname[2*j+1] = ((ses_i_0->sesi0_cname[j])>>4)+'A';
       NBQ.NBname[2*j+2] = ((ses_i_0->sesi0_cname[j])&0x0F)+'A';
       }
     NumberNBN += GetTCPBEUIn((char *)&NBQ, sizeof(NBQ));
     }

   for (i=0; flagRun && (i<ulEntriesRead); i++)
     {
#ifndef DAEMON
     WinPostMsg ( hwndNum, WM_USER_TCPBEUI, MPFROMLONG((long)i), 0L );
#endif
     strcpy(NBQ.NBname,NBN);
     for (j=0; j<strlen(pB+i*(UNCLEN-1)); j++)
       {
       NBQ.NBname[2*j+1] = (pB[i*(UNCLEN-1)+j]>>4)+'A';
       NBQ.NBname[2*j+2] = (pB[i*(UNCLEN-1)+j]&0x0F)+'A';
       }
     NumberNBN += GetTCPBEUIn((char *)&NBQ, sizeof(NBQ));
     }
   return NumberNBN;
}

//=============================================================================
// GetTCPBEUIn - ணࠬ -뢮  ⮪ TCPBEUI
//=============================================================================
int GetTCPBEUIn(char *line, int len)
{
int j, k, NumberNBN = 0, sock;
fd_set r;
char buff[PACKETSIZE];
struct sockaddr_in client;
struct timeval tv;

  sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
  tv.tv_sec = 0;
  tv.tv_usec = TcpWait*1000; //  ७ - ᥪ㭤

  for ( k=0; k<NumIPadr; k++ ) *paddr[k] |= htonl(~AddrInfoIP[k].mask);

  for ( k=0; flagRun && (k<NumIPadr); k++ )
    {
    if ( ChkTCPB[k] )
      {
      setsockopt( sock, SOL_SOCKET, SO_BROADCAST,
                  (char *)&sin[k].sin_addr.s_addr,
                  sizeof(sin[0].sin_addr.s_addr) );

      FD_ZERO(&r);
      myFD_SET(sock, &r);

      sendto( sock, line, len, 0, (struct sockaddr *)&sin[k],
              sizeof(struct sockaddr) );

      memset(buff, 0, PACKETSIZE);
      if ( select(sock+1, &r, NULL, NULL, &pingtv) <= 0 ) continue;
      if ( recvfrom(sock, buff, PACKETSIZE, 0, 0, 0) == -1 ) continue;

      memcpy((char *)&client.sin_addr, buff+58, L4);
      strcpy(NBIP, inet_ntoa(client.sin_addr));
      for (j=13; j<=44; j+=2)
        {
        if ( (buff[j] < 'A') || (buff[j] > 'P') ||
             (buff[j+1] < 'A') || (buff[j+1] > 'P') )
          {
          NB[(j-13)/2] = '\0';
          break;
          }
        NB[(j-13)/2] = ((buff[j]-'A')<<4)+(buff[j+1]-'A');
        if ( NB[(j-13)/2] == ' ' )
          {
          NB[(j-13)/2] = '\0';
          break;
          }
        }
      MACNB+=MACLEN;
      NB += UNCLEN;
      NBIP += IPLEN;
      NumberNBN++;
      }
    }
  soclose(sock);
  return NumberNBN;
}

//=============================================================================
// NETBEUIscan - ணࠬ ᪠஢  ⮪ NETBEUI
//=============================================================================
#ifndef DAEMON
int NETBEUIscan(HWND hwndNum, int NumberNBN)
#else
int NETBEUIscan(int NumberNBN)
#endif
{
   unsigned long handle[MAXIPADR] = { 0, 0, 0, 0, 0, 0, 0, 0 };
   int i, k;
   struct session_info_0 *ses_i_0;

   for ( k=0; k<NumNCB; k++ )
     NetBios32Open(NetName+k*(NETBIOS_NAME_LEN+1), NULL, L1, &handle[k]);

   for ( ses_i_0 = (struct session_info_0 *)pSes, i=0;
         flagRun && (i<ulSesRead); i++, ses_i_0++ )
     {
#ifndef DAEMON
     WinPostMsg ( hwndNum, WM_USER_SESNBEUI, MPFROMLONG((long)i), 0L );
#endif
     for ( k=0; flagRun && (k<NumNCB); k++ )
       {
       NCBB[k].ncb_length = len;
       memset(NCBB[k].ncb_callname, ' ', NCBNAMSZ);
       strncpy( NCBB[k].ncb_callname, ses_i_0->sesi0_cname,
                strlen(ses_i_0->sesi0_cname) );
       if ( NetBios32Submit(handle[k], L0, &NCBB[k]) == 0 )
         {
         strcpy(NB, ses_i_0->sesi0_cname);
         memcpy(MACNB, bufFind, L6);
         NB += UNCLEN;
         MACNB += MACLEN;
         NumberNBN++;
         break;
         }
       }
     }

   for (i=0; flagRun && (i<ulEntriesRead); i++)
     {
#ifndef DAEMON
     WinPostMsg ( hwndNum, WM_USER_NETBEUI, MPFROMLONG((long)i), 0L );
#endif
     for ( k=0; flagRun && (k<NumNCB); k++ )
       {
       NCBB[k].ncb_length = len;
       memset(NCBB[k].ncb_callname, ' ', NCBNAMSZ);
       strncpy(NCBB[k].ncb_callname, pB+i*(UNCLEN-1), strlen(pB+i*(UNCLEN-1)));
       if ( NetBios32Submit(handle[k], L0, &NCBB[k]) == 0 )
         {
         strcpy(NB, pB+i*(UNCLEN-1));
         memcpy(MACNB, bufFind, L6);
         NB += UNCLEN;
         MACNB += MACLEN;
         NumberNBN++;
         break;
         }
       }
     }

   for ( k=0; k<NumNCB; k++ ) NetBios32Close(handle[k], L0);

   return NumberNBN;
}

//=============================================================================
// DoSave - ணࠬ ࠭ १⮢ ᪠஢  ⥪⮢ 
//=============================================================================
void DoSave(char *File, char *mode, BOOL Format)
{
  FILE *OutFile;
  char temp[L32];
  int i;

  strftime(temp, sizeof(temp)-1, "%d/%m/%Y %T", timeptr);
  OutFile = fopen(File, mode);

  fprintf(OutFile, "%s %s\n%s\n", TitleBar, temp, pszCnrTitle);
  if ( Format )
    fprintf(OutFile,
      "Status   IP address       MAC address   NetBIOS name     Host name\n");
  else
    fprintf(OutFile,
      "IP address       MAC address   NetBIOS name     Host name\n");
//     123.123.123.123 1234-1234-1234 123456789x123456

  IP=IPfirst;
  MAC=MACfirst;
  FQDN=FQDNfirst;
  NETBN=NETBNfirst;
  for (i = 0; i < CurrNum;
       i++, IP += IPLEN, MAC += MACLEN, FQDN += FQDNLEN, NETBN += UNCLEN)
    {
    if ( Format )
      fprintf( OutFile, "%-8.8s %-15s %-14s %-16s %s\n",
               TxtExist+StatusIP[i], IP, MAC, NETBN, FQDN );
    else
      {
      if ( (StatusIP[i]==TxtDel-TxtExist)||(StatusIP[i]==TxtRepl-TxtExist) )
        continue;
      fprintf(OutFile, "%-15s %-14s %-16s %s\n", IP, MAC, NETBN, FQDN);
      }
    }

  fclose(OutFile);
}

//=============================================================================
// TestAddr - ணࠬ ஢ન  IP-  ᯨ᪥ 䥩ᮢ
//=============================================================================
BOOL TestAddr(int k)
{
int i, sock;

   sock = socket(AF_INET, SOCK_DGRAM, 0);
#ifndef TCPV40HDRS   // ᪫  TCP/IP 4.0
   os2_ioctl(sock, SIOSTATAT, (char *)buf, sizeof(buf));
#else                //   TCP/IP 4.0
   ioctl(sock, SIOSTATAT, (char *)buf, sizeof(buf));
#endif               // TCPV40HDRS
   soclose(sock);

   for ( i=0, AdrInfo=(struct statatreq *)&buf[2]; i < *pi; i++, AdrInfo++ )
     {
#ifdef TCPV40HDRS   //   TCP/IP 4.0
     if ( (sin[k].sin_addr.s_addr == AdrInfo->addr) &&
          (AdrInfo->interface >= 0) &&       //  
          (AdrInfo->interface < MAXIPADR) )  // lan0 - lan7
#else
     if ( (sin[k].sin_addr.s_addr == AdrInfo->addr) &&
          (AdrInfo->interface >= 0) &&        //  
          (AdrInfo->interface < MAXIPADR) &&  // lan0 - lan7
          ((AdrInfo->addr & 0x000000ff) != 0x0000007f) ) //  loopback
#endif
       {
       memcpy((char *)&AddrInfoIP[k], AdrInfo, sizeof(struct statatreq));
       return TRUE;
       }
     }
   return FALSE;
}

//=============================================================================
// FormNCB - ணࠬ ஥  NCB  ⮢  TCPBEUI
//=============================================================================
void FormNCB(void)
{
  int i, j;
  unsigned long ERead, EAvailable;

  NumNCB = 0;
  memset(ChkTCPB, '\0', sizeof(ChkTCPB));

  if ( NetBios32Enum(NULL,L1,bufFind,len,&ERead,&EAvailable) != 0 ) return;

  for ( i=0; i<ERead; i++)
    {
    if (strcmpi(NBI1[i].nb1_driver_name, "NETBEUI$") == 0)
      {
      if ( NBadrSet && NBadrM[NBI1[i].nb1_lana_num] )
        {
        strcpy(NetName+NumNCB*(NETBIOS_NAME_LEN+1), NBI1[i].nb1_net_name);
        NCBB[NumNCB].ncb_command = NCBASTAT;    // NCB.STATUS
        NCBB[NumNCB].ncb_buffer = bufFind;
        NCBB[NumNCB].ncb_lana_num = NBI1[i].nb1_lana_num;
        NumNCB++;
        continue;
        }

      if ( NBadrSet ) continue;
      for ( j=0; j<NumIPadr; j++ )
        if ( NBI1[i].nb1_lana_num == AddrInfoIP[j].interface )
          {
          strcpy(NetName+NumNCB*(NETBIOS_NAME_LEN+1), NBI1[i].nb1_net_name);
          NCBB[NumNCB].ncb_command = NCBASTAT;    // NCB.STATUS
          NCBB[NumNCB].ncb_buffer = bufFind;
          NCBB[NumNCB].ncb_lana_num = NBI1[i].nb1_lana_num;
          NumNCB++;
          break;
          }
      }
    else
      if (strcmpi(NBI1[i].nb1_driver_name, "TCPBEUI$") == 0)
        {
        if ( NBadrSet && NBadrM[NBI1[i].nb1_lana_num] )
          {
          for ( j=0; j<NumIPadr; j++ ) ChkTCPB[j] = TRUE;
          continue;
          }

        if ( NBadrSet ) continue;
        for ( j=0; j<NumIPadr; j++ )
          if (NBI1[i].nb1_lana_num == AddrInfoIP[j].interface) ChkTCPB[j]=TRUE;
        }
    }
}

//=============================================================================
// GetIPaddr - ணࠬ 宦 IP-   䥩
//=============================================================================
void GetIPaddr(short j)
{
int i, sock;

  sock = socket(AF_INET, SOCK_DGRAM, 0);
#ifndef TCPV40HDRS   // ᪫  TCP/IP 4.0
  os2_ioctl(sock, SIOSTATAT, (char *)buf, sizeof(buf));
#else                //   TCP/IP 4.0
  ioctl(sock, SIOSTATAT, (char *)buf, sizeof(buf));
#endif               // TCPV40HDRS
  soclose(sock);

  for ( i=0, AdrInfo=(struct statatreq *)&buf[2]; i < *pi; i++, AdrInfo++ )
    {
#ifdef TCPV40HDRS   //   TCP/IP 4.0
    if ( (AdrInfo->interface == j) &&
         ((AdrInfo->addr & 0x000000ff) != 0x0000007f) )  //  loopback
#else
    if ( AdrInfo->interface == j )
#endif
      {
      sin[NumIPadr].sin_family = AF_INET;
      sin[NumIPadr].sin_addr.s_addr = AdrInfo->addr;
      memcpy((char *)&AddrInfoIP[NumIPadr], AdrInfo, sizeof(struct statatreq));
      NumIPadr++;
      if ( NumIPadr == MAXIPADR ) return;
      }
    }
}

//=============================================================================
// GetIPname - ணࠬ 宦  
//=============================================================================
#ifndef DAEMON
void GetIPname(HWND hwnd, char *ptr, u_long i)
#else
void GetIPname(char *ptr, u_long i)
#endif
{
struct hostent *hent;

   if ( !useDNS ) return;

#ifndef DAEMON
   WinPostMsg (hwnd, WM_USER_DNS, MPFROMLONG(i), 0L);
#endif

   if ( (hent = gethostbyaddr(ptr, L4, AF_INET)) != NULL )
     sprintf(FQDN, "%0.63s",hent->h_name);
}

//=============================================================================
// PingRange - ணࠬ 믮 PING   ᮢ
//=============================================================================
#ifndef DAEMON
void PingRange(HWND hwnd, int j)
#else
void PingRange(int j)
#endif
{
u_long len, num, start, stop;
struct sockaddr_in whereto;   // Who to ping
u_char outpack[PING_MAXPACKET];
struct icmp *icp = (struct icmp *)outpack;
u_char *datap = (u_char *)(icp->icmp_data);
u_char inpack[PING_MAXPACKET];
struct ip *ip = (struct ip *)inpack;
fd_set r;
int sock;

   strcpy(IP, LineSep);
   strcpy(MAC, LineSep);
   strcpy(FQDN, LineSep);
   IP += IPLEN;
   MAC += MACLEN;
   FQDN += FQDNLEN;
   NETBN += UNCLEN;
#ifndef DAEMON
   WinPostMsg ( hwnd, WM_USER_LINE_DONE,
                MPFROMLONG(CurrNum), MPFROM2SHORT(NumOUI, 0) );
#endif
   CurrNum++;
   start = htonl(PingStart[j]);
   stop = htonl(PingStop[j]);

   sock = socket(PF_INET, SOCK_RAW, IPPROTO_ICMP);

   memset( (char *)&whereto, 0, sizeof(struct sockaddr_in) );
   whereto.sin_family = PF_INET;
   strcpy(icp->icmp_data, TitleBar);
   strcat(icp->icmp_data, " ABCDEFGHIJKLMNOPRSTUVWXYZ 0123456789 Verify");
   len = strlen(icp->icmp_data) + 1 + (datap-outpack);
   icp->icmp_type = ICMP_ECHO;
   icp->icmp_code = 0;
   icp->icmp_id = 0x3554; // identitier for outbound packet
   icp->icmp_seq = 1;     // sequence number for outbound packet

   for (num=start; flagRun && (num<=stop) && (CurrNum<NUMADR); num++)
     {
#ifndef DAEMON
     WinPostMsg (hwnd, WM_USER_PING, MPFROMLONG(num), 0L);
#endif
     whereto.sin_addr.s_addr = htonl(num);
     icp->icmp_cksum = 0;
     icp->icmp_cksum = in_cksum( (u_short*)icp, len ); // Compute ICMP CheckSum

     FD_ZERO(&r);
     myFD_SET(sock, &r);

     sendto( sock, (char *)outpack, len, 0, (struct sockaddr *)&whereto,
             sizeof(struct sockaddr_in) );

     if ( select(sock+1, &r, NULL, NULL, &pingtv) <= 0 ) continue;
     if ( recvfrom(sock, inpack, PING_MAXPACKET, 0, 0, 0) == -1) continue;
     sprintf( IP, "%s", inet_ntoa(ip->ip_src) );

#ifdef DAEMON
     GetIPname((char *)&whereto.sin_addr.s_addr, whereto.sin_addr.s_addr);
#else
     GetIPname(hwnd,(char *)&whereto.sin_addr.s_addr,whereto.sin_addr.s_addr);
#endif
     IP += IPLEN;
     MAC += MACLEN;
     FQDN += FQDNLEN;
     NETBN += UNCLEN;
#ifndef DAEMON
     WinPostMsg ( hwnd, WM_USER_LINE_DONE,
                  MPFROMLONG(CurrNum++), MPFROM2SHORT(NumOUI, 0) );
#endif
     CurrNum++;
     }
   soclose(sock);
}

//=============================================================================
// TestBEUI - ணࠬ ஢ન ᪠ Lan Requester (Lan Server)
//=============================================================================
BOOL TestBEUI(void)
{
  if (Net32WkstaGetInfo(NULL, L1, Net32Buf, L1024, &ulEntriesAvailable) != 0)
    return FALSE;

  ulSesRead = ulSesAvailable = 0;
  Net32SessionEnum( NULL, L0, pSes, L4096, &ulSesRead, &ulSesAvailable );

  return TRUE;
}

//=============================================================================
// SetTitle - ணࠬ ନ஢ 
//=============================================================================
void SetTitle (BOOL NETparm)
{
int i, j;

  sprintf(pszCnrTitle, "Network(s) -");

  for ( i=0; i<NumIPadr; i++ )
    {
    j = strlen(pszCnrTitle);
    *paddr[i] &= htonl(AddrInfoIP[i].mask);
    sprintf(pszCnrTitle+j, " %s", inet_ntoa(*inaddr[i]));
    }

  for ( i=0; i<NumPing; i++ )
    {
    j=strlen(pszCnrTitle);
    sprintf(pszCnrTitle+j, " %s", inet_ntoa(*(struct in_addr *)&PingStart[i]));
    j = strlen(pszCnrTitle);
    sprintf(pszCnrTitle+j, "-%s",inet_ntoa(*(struct in_addr *)&PingStop[i]));
  }

  if ( !NETparm ) return;

  j=strlen(pszCnrTitle);
  sprintf( pszCnrTitle+j, "     Domain - %s     Computer - %s",
          pWkInf->wki1_logon_domain, pWkInf->wki1_computername );
}

//=============================================================================
// CFGpgm - ணࠬ 䨣஢ LanScan
//=============================================================================
void APIENTRY CFGpgm(void)
{
struct sockaddr_in server; // server address information
struct sockaddr_in client; // client address information
struct servent *CFGprot;
int srvsock;    // socket for accepting connections
int ns;         // socket connected to client
int namelen = sizeof(client);    // length of client name
char CFGbuf[PWDLEN+L4];
int len;
FILE *File;
fd_set r;
ULONG Post;

  DosSetPriority(PRTYS_THREAD, PRTYC_REGULAR, L15, L0);
#ifdef DAEMON
  if ( (CFGprot = getservbyname("LanScanC", "tcp")) == NULL )
    {
    printf("Can not found LanScanC port\n");
    exit(L0);
    }
#else
  if ( (CFGprot = getservbyname("LanScanC", "tcp")) == NULL ) return;
#endif
  srvsock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

  memset(&server, '\0', sizeof(server));
  server.sin_family = AF_INET;
  server.sin_port = CFGprot->s_port;
  server.sin_addr.s_addr = INADDR_ANY;

// Bind the socket to the server address.
#ifdef DAEMON
  if ( bind(srvsock, (struct sockaddr *)&server, sizeof(server)) != 0 )
    {
    printf("Can not bind to LanScanC port\n");
    exit(L0);
    }
  printf("Successful bind to LanScanC port\n");
#else
  if ( bind(srvsock, (struct sockaddr *)&server, sizeof(server)) != 0 )
    {
    soclose(srvsock);
    return;
    }
#endif
// Listen for connections. Specify the backlog as 0.
  listen(srvsock, L0);

  for (;;)
    {
// Accept a connection.
    ns = accept(srvsock, (struct sockaddr *)&client, &namelen);

    FD_ZERO(&r);
    myFD_SET(ns, &r);
    select(ns+1, &r, NULL, NULL, NULL);
// Receive the message on the newly connected socket.
    memset(CFGbuf, '\0', sizeof(CFGbuf));
    len = recv(ns, CFGbuf, PWDLEN+L4, L0);

    if ( (memcmp(CFGbuf, "Get", L3) == 0) &&
         (memcmp(CFGbuf+3, ReadPWD, strlen(ReadPWD)+1) == 0) )
      {
      if ( flagSet )
        {
        soclose(ns);
        continue;
        }
      flagSet = TRUE;
      SaveOpt(CFGname);
      flagSet = FALSE;

// Send the Configuration to Client.
      SndFile(ns, CFGname);
      continue;
      }

    if ( (memcmp(CFGbuf, "Put", L3) == 0) &&
         (memcmp(CFGbuf+3, WritePWD, strlen(WritePWD)+1) == 0) )
      {
//  Receive the configuration
      if ( !RcvFile(ns, CFGname) ) continue;
      GetOpt(CFGname);

      DosQueryEventSem( hevEventHandle, &Post );
      if ( flagSet || Post )
        {
        FlagNewCFG = TRUE;
        continue;
        }

      flagSet = TRUE;
      NumIPadr = 0;
      IniFormIP();
      SaveOpt(INIname);
      FlagNewCFG = FALSE;
      flagSet = FALSE;

      continue;
      }
    soclose(ns);
    }
}

//=============================================================================
// IniFormIP - ணࠬ ନ஢ IP-ᮢ  INI-䠩
//=============================================================================
void IniFormIP(void)
{
int i, j;

  for ( i=0; i<MAXIPADR; i++) Interv[i] = 0;

  for ( i=0; i<TempNumIPadr; i++)
     {
     sin[NumIPadr].sin_family = AF_INET;
     sin[NumIPadr].sin_addr.s_addr = TempAddrInfo[i].addr;
     if ( !TestAddr(NumIPadr) ) continue;

     if ( TempInterv[i] == 0 )
       {
       NumIPadr++;
       continue;
       }

     for ( j=0; j<TempInterv[i]; j++ )
       {
       HostInt[NumIPadr].start[j] = TempHostInt[i].start[j];
       HostInt[NumIPadr].stop[j] = TempHostInt[i].stop[j];
       HostInt[NumIPadr].start[j] &= ~AddrInfoIP[NumIPadr].mask;
       HostInt[NumIPadr].stop[j]  &= ~AddrInfoIP[NumIPadr].mask;

       if ((HostInt[NumIPadr].start[j] == 0) ||
           (HostInt[NumIPadr].start[j] > HostInt[NumIPadr].stop[j]) ||
           (HostInt[NumIPadr].stop[j] == ~AddrInfoIP[NumIPadr].mask)) return;

       Interv[NumIPadr]++;
       }
     NumIPadr++;
     }
}

//=============================================================================
// ViewPgm - ணࠬ    १ ᪠஢
//=============================================================================
void APIENTRY ViewPgm(void)
{
struct sockaddr_in server; // server address information
struct sockaddr_in client; // client address information
struct servent *ViewProt;
int srvsock;    // socket for accepting connections
int ns;         // socket connected to client
int namelen = sizeof(client);    // length of client name
char ViewBuf[PWDLEN+L4];
fd_set r;

  DosSetPriority(PRTYS_THREAD, PRTYC_REGULAR, L15, L0);
#ifdef DAEMON
  if ( (ViewProt = getservbyname("LanScanV", "tcp")) == NULL )
    {
    printf("Can not found LanScanV port\n");
    exit(L0);
    }
#else
  if ( (ViewProt = getservbyname("LanScanV", "tcp")) == NULL ) return;
#endif
  FlagSrv = TRUE;

  srvsock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

  memset(&server, '\0', sizeof(server));
  server.sin_family = AF_INET;
  server.sin_port = ViewProt->s_port;
  server.sin_addr.s_addr = INADDR_ANY;

// Bind the socket to the server address.
#ifdef DAEMON
  if ( bind(srvsock, (struct sockaddr *)&server, sizeof(server)) != 0 )
    {
    printf("Can not bind to LanScanV port\n");
    exit(L0);
    }
  printf("Successful bind to LanScanV port\n");
#else
  if ( bind(srvsock, (struct sockaddr *)&server, sizeof(server)) != 0 )
    {
    soclose(srvsock);
    return;
    }
#endif
// Listen for connections. Specify the backlog as Maximum.
  listen(srvsock, SOMAXCONN);

// Wait indefinitely
  for (;;)
    {
    FD_ZERO(&r);
    myFD_SET(srvsock, &r);

    select(srvsock+1, &r, NULL, NULL, NULL);

// Accept a connection.
    ns = accept(srvsock, (struct sockaddr *)&client, &namelen);

// Create Thread
    _beginthread(SendResult, L0, L65536, (void *)ns);
    }
}

//=============================================================================
// SendResult - ணࠬ 뫪 १⮢ ᪠஢
//=============================================================================
void SendResult(void *arg)
{
int sock;
char ViewBuf[PWDLEN+L4];
ULONG Post;
char FileResultName[L32];

  sock = (int)arg;

// Receive the message on the newly connected socket.
  memset(ViewBuf, '\0', sizeof(ViewBuf));
  recv(sock, ViewBuf, PWDLEN+L4, L0);

  if ( (memcmp(ViewBuf, "Run", L3) == 0) &&
       (memcmp(ViewBuf+3, RunPWD, strlen(RunPWD)+1) == 0) )
    {
    soclose(sock);
    DosQueryEventSem( hevEventHandle, &Post );
    if ( Post == 0 ) DosPostEventSem(hevEventHandle);
    return;
    }

  if ( (memcmp(ViewBuf, "See", L3) == 0) &&
       (memcmp(ViewBuf+3, ViewPWD, strlen(ViewPWD)+1) == 0) )
    {
    DosEnterCritSec();
    strcpy(FileResultName, FileSrvName);
    DosExitCritSec();

    if ( FileResultName[0] == '\0')
      {
      soclose(sock);
      return;
      }
// Send the Result to the client.
    SndFile(sock, FileResultName);
    }
}

//=============================================================================
// AfterScan - ணࠬ 믮  ⢨ ᫥ ᪠஢
//=============================================================================
void AfterScan(void)
{
char FileName[L32], DateTime[L32];
RXSTRING arg;             // argument string for REXX
RXSTRING rexxretval;      // return value from REXX
static UCHAR *strC = "C"; // Log   騩 䠩
static UCHAR *strS = "S"; // Log   ⤥ 䠩
SHORT rexxrc = 0;         // return code from function

  DoSave("LanScan.Net", "a", NewFormat);

  if ( AutoLog && CommonLog )
    {
    DoSave("LanScan.Log", "a", OldFormat);
    MAKERXSTRING(arg, strC, strlen(strC)); // create argument
    }

  if ( FlagSrv || ( AutoLog && !CommonLog ) )
    {
    strftime(DateTime,sizeof(DateTime)-1,"%Y%m%d-%H%M%S",timeptr);
    sprintf(FileName,"LanScan-%s.Log",DateTime);
    DoSave(FileName, "w", OldFormat);
    MAKERXSTRING(arg, strS, strlen(strS)); // create argument
    }

  if ( FlagSrv )
    {
    DosEnterCritSec();
    memset(FileSrvName, '\0', sizeof(FileSrvName));
    strcpy(FileSrvName, FileName);
    DosExitCritSec();
    }

  if ( AutoLog ) RexxStart( L1, (PRXSTRING) &arg, (PSZ) "LanScanP.cmd",
                            (PRXSTRING) 0, (PSZ) 0, (LONG) RXCOMMAND,
                            (PRXSYSEXIT) 0, (PSHORT) &rexxrc,
                            (PRXSTRING) &rexxretval );

  if ( AutoSave )
    if ( szFullPath[0] != '\0' ) DoSave(szFullPath, "w", OldFormat);
    else
      if (GetFileName(szTitle, szFullPath)) DoSave(szFullPath,"w",OldFormat);

  if ( FlagNewCFG )
    {
    flagSet = TRUE;
    NumIPadr = 0;
    IniFormIP();
    SaveOpt(INIname);
    flagSet = FALSE;
    }

  flagRun = TRUE;
  if ( AutoRun ) DosAsyncTimer( (ULONG)Interval*60000L,
                                (HSEM)hevEventHandle, &phtimer );
}

//=============================================================================
// StartThreads - ணࠬ ᪠ ⮪
//=============================================================================
#ifndef DAEMON
void StartThreads(HWND hwnd)
#else
void StartThreads(void)
#endif
{
  DosSetPriority(PRTYS_THREAD, PRTYC_REGULAR, L16, L0);

  DosCreateEventSem( (ULONG)NULL, &hevEventHandle, DC_SEM_SHARED, TRUE );

#ifndef DAEMON
  DosCreateEventSem( (ULONG)NULL, &hevEventStart,  DC_SEM_SHARED, FALSE );
  DosCreateThread( &tid, (PFNTHREAD) DoScan, hwnd,
                   CREATE_READY | STACK_SPARSE, L65536 );
#else
  DosCreateThread( &tid, (PFNTHREAD) DoScan, L0,
                   CREATE_READY | STACK_SPARSE, L65536 );
#endif
  DosCreateThread( &tidCFG, (PFNTHREAD) CFGpgm, L0,
                   CREATE_READY | STACK_SPARSE, L65536 );
  DosCreateThread( &tidView, (PFNTHREAD) ViewPgm, L0,
                   CREATE_READY | STACK_SPARSE, L65536 );
}

#ifndef DAEMON
#include "SubPgm\DlgProcARP.c"
#include "SubPgm\DlgProcOPT.c"
#include "SubPgm\DlgProcPING.c"
#include "SubPgm\InitContainer.c"
#include "SubPgm\Insertrecord.c"
#include "SubPgm\PostErrMsg.c"
#include "SubPgm\SendErrMsg.c"
#include "SubPgm\SendWngMsg.c"
#endif

#include "SubPgm\FindOUI.c"
#include "SubPgm\GetFileName.c"
#include "SubPgm\GetStorage.c"
#include "SubPgm\GetOpt.c"
#include "SubPgm\in_cksum.c"
#include "SubPgm\RcvFile.c"
#include "SubPgm\SaveOpt.c"
#include "SubPgm\SndFile.c"
#include "SubPgm\TestInt.c"
#include "SubPgm\TestPing.c"